<template>
  <i ref="icon" class="icon" :class="[rotationClass, {flipX, flipY, spin}]">
    <slot></slot>
  </i>
</template>

<script>
export default {
  name: 'b-icon',
  props: {
    rotate: String,
    flipX: Boolean,
    flipY: Boolean,
    spin: Boolean
  },
  computed: {
    rotationClass() {
      if(!this.rotate) return '';
      return 'rotate-'+this.rotate;
    }
  },
  mounted() {
    this.$refs.icon.querySelector('svg').setAttribute('viewBox', '0 0 45 45');
  }
}
</script>

<style scoped lang="scss">
  i {
    display: inline-block;
    font-size: inherit;
    transform: translateY(11.22222%);
    transition: transform 0.3s;
    svg {
      width: 1em;
      height: auto;
      display: block;
    }
    *:not([fill=none]) {
      fill: currentColor;
    }
  }
  .rotate {
    &-1x {
      transform: translateY(11.22222%) rotate(90deg);
    }
    &-2x {
      transform: translateY(11.22222%) rotate(180deg);
    }
    &-3x {
      transform: translateY(11.22222%) rotate(-90deg);
    }
  }
  .flipX {
    transform: translateY(11.22222%) scaleX(-1);
  }
  .flipY {
    transform: translateY(11.22222%) scaleY(-1);
  }
  .spin {
    animation-name: spin;
    animation-duration: 1200ms;
    animation-iteration-count: infinite;
    animation-timing-function: linear;
  }
  @keyframes spin {
    from {
        transform:translateY(11.22222%) rotate(0deg);
    }
    to {
        transform:translateY(11.22222%) rotate(360deg);
    }
}
</style>

<docs>
  Ícones
</docs>

